'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _isEqual = require('lodash/isEqual');

var _isEqual2 = _interopRequireDefault(_isEqual);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactabularUtils = require('reactabular-utils');

var _types = require('./types');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Body = function (_React$Component) {
  _inherits(Body, _React$Component);

  function Body(props) {
    _classCallCheck(this, Body);

    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(Body).call(this, props));

    _this.ref = null;
    return _this;
  }

  _createClass(Body, [{
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps, nextState, nextContext) {
      // Skip checking props against `onRow` since that can be bound at render().
      // That's not particularly good practice but you never know how the users
      // prefer to define the handler.
      return !((0, _isEqual2.default)(omitOnRow(this.props), omitOnRow(nextProps)) && (0, _isEqual2.default)(this.context, nextContext));
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props;
      var onRow = _props.onRow;
      var rows = _props.rows;
      var rowKey = _props.rowKey;

      var props = _objectWithoutProperties(_props, ['onRow', 'rows', 'rowKey']);

      var _context = this.context;
      var bodyColumns = _context.bodyColumns;
      var components = _context.components;


      props.ref = function (body) {
        _this2.ref = body;
      };

      return _react2.default.createElement(components.body.wrapper, props, rows.map(function (r, i) {
        if (process.env.NODE_ENV !== 'production') {
          // Arrays cannot have rowKeys by definition so we have to go by index there.
          if (!Array.isArray(r) && !{}.hasOwnProperty.call(r, rowKey)) {
            console.warn( // eslint-disable-line no-console
            'Table.Body - Missing valid rowKey!', r, rowKey);
          }
        }

        return _react2.default.createElement(BodyRow, {
          key: (r[rowKey] || i) + '-row',
          components: components.body,
          onRow: onRow,
          row: r,
          rowIndex: i,
          rowData: rows[i],
          columns: bodyColumns
        });
      }));
    }
  }, {
    key: 'getRef',
    value: function getRef() {
      return this.ref;
    }
  }]);

  return Body;
}(_react2.default.Component);

exports.default = Body;

process.env.NODE_ENV !== "production" ? Body.propTypes = _types.tableBodyTypes : void 0;
Body.defaultProps = {
  onRow: function onRow() {}
};
Body.contextTypes = _types.tableBodyContextTypes;

function omitOnRow(props) {
  var onRow = props.onRow;

  var ret = _objectWithoutProperties(props, ['onRow']); // eslint-disable-line no-unused-vars

  return ret;
}

var BodyRow = function (_React$Component2) {
  _inherits(BodyRow, _React$Component2);

  function BodyRow() {
    _classCallCheck(this, BodyRow);

    return _possibleConstructorReturn(this, Object.getPrototypeOf(BodyRow).apply(this, arguments));
  }

  _createClass(BodyRow, [{
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps) {
      var previousProps = this.props;

      return !((0, _isEqual2.default)(previousProps.columns, nextProps.columns) && (0, _isEqual2.default)(previousProps.row, nextProps.row) && (0, _isEqual2.default)(previousProps.rowData, nextProps.rowData));
    }
  }, {
    key: 'render',
    value: function render() {
      var _props2 = this.props;
      var columns = _props2.columns;
      var components = _props2.components;
      var row = _props2.row;
      var onRow = _props2.onRow;
      var rowIndex = _props2.rowIndex;
      var rowData = _props2.rowData;


      return _react2.default.createElement(components.row, onRow(row, rowIndex), columns.map(function (_ref, j) {
        var column = _ref.column;
        var cell = _ref.cell;
        var property = _ref.property;
        var props = _ref.props;

        var _ref2 = cell || {};

        var _ref2$transforms = _ref2.transforms;
        var transforms = _ref2$transforms === undefined ? [] : _ref2$transforms;
        var _ref2$format = _ref2.format;
        var format = _ref2$format === undefined ? function (a) {
          return a;
        } : _ref2$format; // TODO: test against this case

        var extraParameters = {
          columnIndex: j,
          column: column,
          rowData: rowData,
          rowIndex: rowIndex,
          property: property
        };
        var transformed = (0, _reactabularUtils.evaluateTransforms)(transforms, row[property], extraParameters);

        if (!transformed) {
          console.warn('Table.Body - Failed to receive a transformed result'); // eslint-disable-line max-len, no-console
        }

        return _react2.default.createElement(components.cell, _extends({
          key: j + '-cell'
        }, (0, _reactabularUtils.mergePropPair)(props, transformed)), transformed.children || format(row['_' + property] || row[property], extraParameters));
      }));
    }
  }]);

  return BodyRow;
}(_react2.default.Component);

BodyRow.defaultProps = {
  onRow: function onRow() {
    return {};
  }
};
process.env.NODE_ENV !== "production" ? BodyRow.propTypes = {
  columns: _react2.default.PropTypes.array.isRequired,
  components: _react2.default.PropTypes.object,
  row: _react2.default.PropTypes.oneOfType([_react2.default.PropTypes.array, _react2.default.PropTypes.object]),
  onRow: _react2.default.PropTypes.func,
  rowIndex: _react2.default.PropTypes.number.isRequired,
  rowData: _react2.default.PropTypes.oneOfType([_react2.default.PropTypes.array, _react2.default.PropTypes.object]).isRequired
} : void 0;